// Code generated by tablegen. DO NOT EDIT.
package tables

func (t AllTables) Events() Events { return Events(t) }

type Events struct{ alias string }

func (t Events) TableAlias() string { return t.alias }
func (t Events) name() string       { return "Events" }
func (t Events) TableName() string  { return tableName(t.name(), "", t.alias) }
func (t Events) AllColumnNames() []string {
	c := t.Columns()
	return []string{
		c.ID(),
		c.AppID(),
		c.UserID(),
		c.CircleID(),
		c.CreatedAt(),
		c.EventKind(),
	}
}

func (t Events) Columns() EventsCols { return EventsCols{tableAlias: t.alias} }

type EventsCols struct{ tableAlias string }

func (c EventsCols) ID() string        { return colName(c.tableAlias, "ID") }        // STRING(36)
func (c EventsCols) AppID() string     { return colName(c.tableAlias, "AppID") }     // STRING(36) NULL
func (c EventsCols) UserID() string    { return colName(c.tableAlias, "UserID") }    // STRING(36) NULL
func (c EventsCols) CircleID() string  { return colName(c.tableAlias, "CircleID") }  // STRING(36) NULL
func (c EventsCols) CreatedAt() string { return colName(c.tableAlias, "CreatedAt") } // TIMESTAMP
func (c EventsCols) EventKind() string { return colName(c.tableAlias, "EventKind") } // STRING(100)

func (t Events) Indexes() EventsIndexes { return EventsIndexes{table: t} }

type EventsIndexes struct{ table Events }

func (i EventsIndexes) ByEventKindCreatedAt() Index {
	c := i.table.Columns()
	return Index{
		tableAlias: i.table.alias,
		tableName:  i.table.name(),
		indexName:  "Events_EventKind_CreatedAt",
		columns: []string{
			c.ID(),
			c.UserID(),
			c.CreatedAt(),
			c.EventKind(),
		},
	}
}

func (i EventsIndexes) ByEventKindUserIDCreatedAtDesc() Index {
	c := i.table.Columns()
	return Index{
		tableAlias: i.table.alias,
		tableName:  i.table.name(),
		indexName:  "Events_EventKind_UserID_CreatedAt_DESC",
		columns: []string{
			c.ID(),
			c.UserID(),
			c.CreatedAt(),
			c.EventKind(),
		},
	}
}
